package com.agiledeveloper.archchecks;

import com.tngtech.archunit.core.domain.JavaClasses;
import com.tngtech.archunit.core.importer.ClassFileImporter;
import com.tngtech.archunit.junit.AnalyzeClasses;
import org.junit.jupiter.api.Test;

import static com.tngtech.archunit.lang.syntax.ArchRuleDefinition.classes;

@AnalyzeClasses
public class ModuleExportChecks {
  private JavaClasses classes =
    new ClassFileImporter().importPackages(
      "com.agiledeveloper.calculator"
    );

  @Test
  void moduleExportsOnlyInterfacesExceptionsAndFactories(){
    classes()
      .that()
      .arePublic()
      .should()
      .beInterfaces()
      .orShould()
      .haveSimpleNameEndingWith("Factory")
      .orShould()
      .beAssignableTo(Exception.class)
      .check(classes);
  }
}
